<?php
namespace FM\Factory;
use Doctrine\ORM\EntityManager;
use FM\Traits\TQuery;

class ConformidadesFactory {
    
    use TQuery;

    protected $connection;
    protected $entityManager;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }
    
    // requisição dos dados do card de não conformidades
    public function getDadosCardFactory($param) {
      
        $sql = "SELECT LC.NMLOCALCLIENTE || ' | ' || TLC.NMTIPOLOCALCLI AS NMLOCAL, CTAC.NMCRITERIOTARGERCHK
                  FROM FCM_CRITERIOTARGERCHK CTAC
                  JOIN FCM_TAREFAGERCHK TAC
                    ON CTAC.NRTAREFAGERCHK = TAC.NRTAREFAGERCHK
                  JOIN FCM_GERENCIAMENTOCHK GC
                    ON TAC.NRGERENCIAMENTOCHK = GC.NRGERENCIAMENTOCHK
                  JOIN FCM_LOCALCLI LC
                    ON GC.NRLOCALCLIENTE = LC.NRLOCALCLIENTE
                  JOIN FCM_TIPOLOCALCLI TLC
                    ON LC.NRTIPOLOCALCLI = TLC.NRTIPOLOCALCLI
                  JOIN FCM_CRITERIOTAREFACHK CTC
                    ON CTAC.NRCRITERIOTAREFACHK = CTC.NRCRITERIOTAREFACHK
                  JOIN FCM_CRITERIOTAREFA CT
                    ON CTC.NRCRITERIOTAREFA = CT.NRCRITERIOTAREFA
                 WHERE CTAC.IDMARCADO = 'S'".$param."";
                
        $std = $this->connection->prepare($sql);
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getDadosCardPrincipaisNaoConformidades($param) {
      
      $sql = "SELECT CTCGK.NMCRITERIOTARGERCHK, COUNT(CTCGK.NRCRITERIOTAREFACHK) AS QUANTIDADE
              FROM FCM_CRITERIOTARGERCHK CTCGK
              JOIN FCM_TAREFAGERCHK TGCHK
              ON TGCHK.NRTAREFAGERCHK = CTCGK.NRTAREFAGERCHK
              WHERE IDMARCADO = 'S'".$param."
              GROUP BY CTCGK.NMCRITERIOTARGERCHK, CTCGK.NRCRITERIOTAREFACHK
              ORDER BY QUANTIDADE DESC";
      
      $std = $this->connection->prepare($sql);
        
      $std->execute();
      return $std->fetchAll();
    }
    
    public function buscaTipoLocal() {
        
        $sql = "SELECT NRTIPOLOCALCLI, NMTIPOLOCALCLI
                  FROM FCM_TIPOLOCALCLI WHERE IDTIPOLOCALCLI = 3";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    public function buscaTipoLocalDatasource() {
        
        $sql = "SELECT NRTIPOLOCALCLI, NMTIPOLOCALCLI
                  FROM FCM_TIPOLOCALCLI
                 WHERE IDTIPOLOCALCLI = 3";
        
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
    
    public function buscaSetor() {
        
        $sql = "SELECT NMSETOR,NRSETOR  
                FROM FCM_SETOR";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getDadosAcesso($param) {
      
      $sql = "SELECT FUNC.NRFUNCIONARIO, RELFUNC.NRPERFILACESSO, PERF.IDDIRECIONAQRCODE
                FROM FCM_FUNCIONARIO FUNC
                  JOIN FCM_RELACFUNCPERFACESS RELFUNC
                  ON RELFUNC.NRFUNCIONARIO = FUNC.NRFUNCIONARIO
                  JOIN FCM_PERFILACESSO PERF
                  ON RELFUNC.NRPERFILACESSO = PERF.NRPERFILACESSO
                WHERE FUNC.NRFUNCIONARIO = ".$param."";
    
      $std = $this->connection->prepare($sql);
      $std->execute();
      return $std->fetchAll();
    }
    
    public function getlocalUrlVistoria($param) {
      $sql = "SELECT
                 NRGERENCIAMENTOCHK,
                 DTHORAAGEND,
                 NMLOCALCLIENTE,
                 NMLOCALPAI 
              FROM
                 (
                    SELECT
                       GCHK.NRGERENCIAMENTOCHK,
                       GCHK.DTHORAAGEND,
                       LC.NMLOCALCLIENTE,
                       LCP.NMLOCALCLIENTE AS NMLOCALPAI 
                    FROM
                       FCM_GERENCIAMENTOCHK GCHK 
                       JOIN
                          FCM_LOCALCLI LC 
                          ON LC.NRLOCALCLIENTE = GCHK.NRLOCALCLIENTE 
                       JOIN
                          FCM_LOCALCLI LCP 
                          ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI 
                       JOIN
                          FCM_FUNCIONARIO FUNC 
                          ON GCHK.NRFUNCIONARIO = FUNC.NRFUNCIONARIO 
                       JOIN
                          FCM_CHECKLISTAGEND CA 
                          ON CA.NRCHECKLISTAGEND = GCHK.NRCHECKLISTAGEND 
                    WHERE
                       GCHK.NRLOCALCLIENTE = ". $param['NRLOCALCLIENTE']." 
                       AND IDSITUACAOGERCHK = 1 
                       AND IDSITUACAOAGEND = 4 
                       AND GCHK.NRFUNCIONARIO = ". $param['userLogado']." 
                    ORDER BY
                       GCHK.DTHORAAGEND 
                 )
                 VISTORIA 
              WHERE
                 ROWNUM = 1";
    
      $std = $this->connection->prepare($sql);
      $std->execute();
      return $std->fetchAll();
    }
    
    public function getlocalUrlTarefa($param) {
      $sql = "SELECT
                 NRCHECKLISTAGEND,
                 IDSITUACAOAGEND,
                 DTHORAAGEND 
              FROM
                 (
                    SELECT
                       NRCHECKLISTAGEND,
                       IDSITUACAOAGEND,
                       DTHORAAGEND 
                    FROM
                       FCM_CHECKLISTAGEND 
                    WHERE
                       IDSITUACAOAGEND = 1 
                       AND NRFUNCIONARIO = ". $param['userLogado']." 
                       AND NRLOCALCLIENTE = ". $param['NRLOCALCLIENTE']." 
                    ORDER BY
                       DTHORAAGEND
                 )
                 TAREFAS 
              WHERE
                 ROWNUM = 1";
    
      $std = $this->connection->prepare($sql);
      $std->execute();
      return $std->fetchAll();
    }
    
    public function getTarefaSemVinculo($param) {
      $sql = "SELECT
                 NRCHECKLISTAGEND,
                 IDSITUACAOAGEND,
                 DTHORAAGEND 
              FROM
                 (
                    SELECT
                       NRCHECKLISTAGEND,
                       IDSITUACAOAGEND,
                       DTHORAAGEND 
                    FROM
                       FCM_CHECKLISTAGEND 
                    WHERE
                       IDSITUACAOAGEND = 1 
                       AND NRFUNCIONARIO = NULL 
                       AND NRLOCALCLIENTE = ". $param['NRLOCALCLIENTE']." 
                    ORDER BY
                       DTHORAAGEND
                 )
                 TAREFAS 
              WHERE
                 ROWNUM = 1";
    }
    
    public function getVistoriaSemVinculo($param){
            $sql = "SELECT
                 NRGERENCIAMENTOCHK,
                 DTHORAAGEND,
                 NMLOCALCLIENTE,
                 NMLOCALPAI 
              FROM
                 (
                    SELECT
                       GCHK.NRGERENCIAMENTOCHK,
                       GCHK.DTHORAAGEND,
                       LC.NMLOCALCLIENTE,
                       LCP.NMLOCALCLIENTE AS NMLOCALPAI 
                    FROM
                       FCM_GERENCIAMENTOCHK GCHK 
                       JOIN
                          FCM_LOCALCLI LC 
                          ON LC.NRLOCALCLIENTE = GCHK.NRLOCALCLIENTE 
                       JOIN
                          FCM_LOCALCLI LCP 
                          ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI 
                       JOIN
                          FCM_FUNCIONARIO FUNC 
                          ON GCHK.NRFUNCIONARIO = FUNC.NRFUNCIONARIO 
                       JOIN
                          FCM_CHECKLISTAGEND CA 
                          ON CA.NRCHECKLISTAGEND = GCHK.NRCHECKLISTAGEND 
                    WHERE
                       GCHK.NRLOCALCLIENTE = ". $param['NRLOCALCLIENTE']." 
                       AND IDSITUACAOGERCHK = 1 
                       AND IDSITUACAOAGEND = 4 
                       AND GCHK.NRFUNCIONARIO = NULL 
                    ORDER BY
                       GCHK.DTHORAAGEND 
                 )
                 VISTORIA 
              WHERE
                 ROWNUM = 1";
                 
      $std = $this->connection->prepare($sql);
      $std->execute();
      return $std->fetchAll();
    }
    
    public function getCriterioNaoConformidadeByGestor($params) {
        $whereClausules = "";
        $useParams = false;
        if (array_key_exists("NRLOCALCLIENTE", $params)) {
          $whereClausules .= " AND loc.NRLOCALCLIENTE = :NRLOCALCLIENTE";
          $useParams = true;
        }
        if (array_key_exists("NRTIPOLOCALCLI", $params)) {
          $whereClausules .= " AND loc.NRTIPOLOCALCLI = :NRTIPOLOCALCLI";
          $useParams = true;
        }
        if (array_key_exists("NRSETOR", $params)) {
          $whereClausules .= " AND loc.NRSETOR = :NRSETOR";
          $useParams = true;
        }
        if (array_key_exists("DATEBEGIN", $params) || array_key_exists("DATEEND", $params)) {
          if (array_key_exists("DATEBEGIN", $params) && array_key_exists("DATEEND", $params)) {
            $whereClausules .= " AND TRUNC(c.DTHORAAGEND) BETWEEN TO_DATE('" . $params["DATEBEGIN"] . "' , 'DD/MM/YYYY') AND TO_DATE('" . $params["DATEEND"] . "' , 'DD/MM/YYYY')";
            unset($params["DATEBEGIN"]);
            unset($params["DATEEND"]);
          } else if (array_key_exists("DATEBEGIN", $params)) {
            $whereClausules .= " AND TRUNC(c.DTHORAAGEND) >= TO_DATE('" . $params["DATEBEGIN"] . "' , 'DD/MM/YYYY')";
            unset($params["DATEBEGIN"]);
          } else if (array_key_exists("DATEEND", $params)) {
            $whereClausules .= " AND TRUNC(c.DTHORAAGEND) <= TO_DATE('" . $params["DATEEND"] . "', 'DD/MM/YYYY')";
            unset($params["DATEEND"]);
          }
          $useParams = true;
        }
        $sql = "SELECT hc.NRFUNCIONARIOPAI, ct.DSCRITERIOTAREFA, func.NMFUNCIONARIO,
          func.NRFUNCIONARIO
          FROM FCM_CHECKLISTAGEND c
          INNER JOIN FCM_TAREFAAGEND ta
          ON c.NRCHECKLISTAGEND = ta.NRCHECKLISTAGEND
          INNER JOIN FCM_CRITERIOTARAGEND crit
          ON crit.NRTAREFAAGEND = ta.NRTAREFAAGEND
          INNER JOIN FCM_CRITERIOTAREFACHK critchk
          ON crit.NRCRITERIOTAREFACHK = critchk.NRCRITERIOTAREFACHK
          INNER JOIN FCM_CRITERIOTAREFA ct
          ON critchk.NRCRITERIOTAREFA = ct.NRCRITERIOTAREFA
          INNER JOIN FCM_FUNCIONARIO func
          ON func.NRFUNCIONARIO = c.NRFUNCIONARIO
          INNER JOIN FCM_FUNCIONARIOSHIERARQ hc
          ON hc.NRFUNCIONARIO = func.NRFUNCIONARIO
          INNER JOIN FCM_HIERARQUIAFUNC hcfunc
          ON hcfunc.NRHIERARQUIAFUNC = hc.NRHIERARQUIAFUNC
          INNER JOIN FCM_LOCALCLI loc
          ON loc.NRLOCALCLIENTE = c.NRLOCALCLIENTE
          WHERE hcfunc.IDATIVO LIKE 'S'";
          if ($useParams) {
            $sql .= $whereClausules;
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
          } else {
            $std = $this->connection->prepare($sql);
            $std->execute();
            return $std->fetchAll();
          }
    }
    
}
?>